! file: heinrich.h   ( -*- mode: f90 -*- )

integer nbegin,nend &
     ,ncoupling_periods,ocn_seaice_steps_per_coupling &
     ,atm_steps_per_coupling_period &
     ,ntime_steps_ocn,ntime_steps_atm,ntime_steps_seaice,ntime_steps_landice &
     ,ntime_levels,nboxes_ocn,nboxes_atm,nsurface_boxes_ocn,ntracers_ocn &
     ,NZ,nglacier
      
parameter(ntime_levels=3,nboxes_ocn=4,nboxes_atm=2,ntracers_ocn=2 &
     ,nsurface_boxes_ocn=2,NZ=100,nglacier=1)
      
real*8 S0,sigma_SB
      
! ocean variables:
real*8 time,tbegin,tend &
     ,robert_filter_coeff &
     ,coupling_period,dt_atm,dt_atm_box,dt_ocn,dt_seaice &
     ,tprint,tprint_short,speeding_parameter &
     ,g,rho_0,C_u,Cp_ocn,u_thermohaline,Sv,year &
     ,u12,u23,u34,u41 &
     ,kappa_H_srfc,kappa_H_deep,kappa_V_south,kappa_V_north &
     ,Width_ocn,DepthUpper_ocn,DepthLower_ocn,LengthNorth_ocn,LengthSouth_ocn &
     ,T(ntime_levels,nboxes_ocn,ntracers_ocn), rho(nboxes_ocn) &
     ,T_restart(ntime_levels,nboxes_ocn,ntracers_ocn) &
     ,air_to_sea_flux(nsurface_boxes_ocn,ntracers_ocn) &
     ,air_to_sea_flux_from_restart(nsurface_boxes_ocn,ntracers_ocn) &
     ,L_ocn(nboxes_ocn),D_ocn(nboxes_ocn),W_ocn(nboxes_ocn),V_ocn(nboxes_ocn) &
     ,A_ocn(nboxes_ocn)

! atmospheric variables

real*8 f12_heat(nboxes_atm), f12_water &
     ,incoming_radiation(nboxes_atm),longwave_outgoing(nboxes_atm) &
     ,T_atm(ntime_levels,nboxes_atm) &
     ,L_atm(nboxes_atm),W_atm(nboxes_atm),A_atm(nboxes_atm) &
     ,albedo(nboxes_atm) &
     ,frac_land(nboxes_atm),emissivity(nboxes_atm) &
     ,albedo_clouds(nboxes_atm),albedo_land(nboxes_atm) &
     ,albedo_seaice,albedo_ocean &
     ,solar_incoming_radiation(nboxes_atm) &
     ,K_heat_atm &
     ,K_water_atm_dq_dy_bndry,K_water_atm_q_target,K_water_atm_marotzke &
     ,C_bulk_air_sea_heat_flux &
     ,Cp_atm,convert_to_Pw(nboxes_atm)

! seaice variables:
real*8 T_freezing,ice_fusion_heat,rho_ice,seaice_growth_thickness &
     ,shotrwave_penetration_to_seaice &
     ,V_seaice(ntime_levels,nsurface_boxes_ocn),frac_seaice(nsurface_boxes_ocn)&
     ,ocean_to_seaice_flux(1:nsurface_boxes_ocn,1:ntracers_ocn) &
     ,shortwave_to_seaice_heat_flux(1:nsurface_boxes_ocn) &
     ,thickness_seaice(1:nsurface_boxes_ocn) &
     ,seaice_restoring_time

!  landice variables
real*8 T_land_ice(ntime_levels,NZ,nglacier),H(ntime_levels,1:nglacier) &
     ,Abl(nglacier),Acc(nglacier),stage(1:nglacier) &
     ,Geothermal_heat,ice_thermal_cond,Cp_ice,tau &
     ,lapse_rate,abl_rate,dt_land_ice,area_land_ice(nglacier) &
     ,land_to_sea_flux(1:nsurface_boxes_ocn,1:ntracers_ocn,nglacier) &
     ,lat_glr(nglacier),lat_par(nglacier),acc_factor(nglacier)

logical restoring_conditions,use_equiv_t &
     ,write_restart_data,read_restart_data &
     ,no_reversed_THC &
     ,print_atm_in_Pwatts

parameter(Sv=1.e6,year=3600.0*24.0*365.0)


common /Ccoupled/ &
     time,tbegin,tend &
     ,coupling_period,dt_atm,dt_atm_box,dt_ocn,dt_seaice &
     ,tprint,tprint_short,speeding_parameter &
     ,robert_filter_coeff &
     ! integer:
     ,ncoupling_periods,ocn_seaice_steps_per_coupling &
     ,atm_steps_per_coupling_period &
     ,ntime_steps_ocn,ntime_steps_atm,ntime_steps_seaice,ntime_steps_landice

common /Cocn/ &
     ! real:
     T,T_restart,rho,air_to_sea_flux,air_to_sea_flux_from_restart &
     ,u12,u23,u34,u41 &
     ,kappa_H_srfc,kappa_H_deep,kappa_V_south,kappa_V_north &
     ,Width_ocn,DepthUpper_ocn,DepthLower_ocn &
     ,LengthNorth_ocn,LengthSouth_ocn &
     ,L_ocn,D_ocn,W_ocn,V_ocn,A_ocn &
     ,g,rho_0,S0,C_u,Cp_ocn,u_thermohaline &
     ,land_to_sea_flux  &
     ! logicals: 
     ,write_restart_data,read_restart_data & 
     ,no_reversed_THC

common/Catm/ f12_heat, f12_water &
     ,incoming_radiation,longwave_outgoing &
     ,T_atm &
     ,L_atm,W_atm,A_atm &
     ,sigma_SB,albedo &
     ,frac_land,emissivity &
     ,albedo_clouds,albedo_land &
     ,albedo_seaice,albedo_ocean &
     ,solar_incoming_radiation &
     ,K_heat_atm &
     ,K_water_atm_dq_dy_bndry,K_water_atm_q_target,K_water_atm_marotzke &
     ,C_bulk_air_sea_heat_flux &
     ,Cp_atm,convert_to_Pw &
     ,print_atm_in_Pwatts

common/Cseaice/ T_freezing,ice_fusion_heat,rho_ice,seaice_growth_thickness &
     ,frac_seaice,V_seaice &
     ,shortwave_to_seaice_heat_flux,ocean_to_seaice_flux &
     ,thickness_seaice, shotrwave_penetration_to_seaice &
     ,seaice_restoring_time

common/Clandice/ H,T_land_ice,stage,tau,Abl,Acc,dt_land_ice,Geothermal_heat &
      ,ice_thermal_cond,Cp_ice,lapse_rate,abl_rate,lat_glr,area_land_ice &
      ,acc_factor,lat_par

namelist /nl_coupled/ &
      coupling_period,dt_atm_box,dt_ocn,dt_seaice,dt_land_ice &
     ,tbegin,tend,speeding_parameter &
     ,tprint,tprint_short &
     ,write_restart_data,read_restart_data &
     ,restoring_conditions,no_reversed_THC 

namelist /nl_ocn/ &
     Width_ocn,DepthUpper_ocn,DepthLower_ocn &
     ,LengthNorth_ocn,LengthSouth_ocn &
     ,g,rho_0,S0,Cp_ocn &
     ,kappa_H_srfc,kappa_H_deep,kappa_V_south,kappa_V_north &
     ,robert_filter_coeff &
     ,C_u


namelist /nl_atm/ &
     frac_land,emissivity &
     ,albedo_clouds,albedo_land &
     ,albedo_seaice,albedo_ocean &
     ,solar_incoming_radiation &
     ,K_heat_atm &
     ,K_water_atm_dq_dy_bndry,K_water_atm_q_target,K_water_atm_marotzke &
     ,C_bulk_air_sea_heat_flux &
     ,sigma_SB,Cp_atm &!,FW_parameterization &
     ,print_atm_in_Pwatts

namelist /nl_seaice/ &
     T_freezing,ice_fusion_heat,seaice_growth_thickness,rho_ice &
     ,shotrwave_penetration_to_seaice,seaice_restoring_time 

namelist /nl_landice/ &
     tau,Geothermal_heat,ice_thermal_cond &
     ,Cp_ice,lapse_rate,abl_rate,stage,lat_glr,area_land_ice,acc_factor

